extern unsigned int ram_address [];
extern unsigned int ram_destination [];
#asm

; aPPack decompressor
; original source by dwedit
; very slightly adapted by utopian
; optimized by Metalbrain

;hl = source
;de = dest

.depack		ld	ixl,128
.apbranch1	ldi
.aploop0	ld	ixh,1		;LWM = 0
.aploop		call 	ap_getbit
		jr 	nc,apbranch1
		call 	ap_getbit
		jr 	nc,apbranch2
		ld 	b,0
		call 	ap_getbit
		jr 	nc,apbranch3
		ld	c,16		;get an offset
.apget4bits	call 	ap_getbit
		rl 	c
		jr	nc,apget4bits
		jr 	nz,apbranch4
		ld 	a,b
.apwritebyte	ld 	(de),a		;write a 0
		inc 	de
		jr	aploop0
.apbranch4	and	a
		ex 	de,hl 		;write a previous byte (1-15 away from dest)
		sbc 	hl,bc
		ld 	a,(hl)
		add	hl,bc
		ex 	de,hl
		jr	apwritebyte
.apbranch3	ld 	c,(hl)		;use 7 bit offset, length = 2 or 3
		inc 	hl
		rr 	c
		ret 	z		;if a zero is encountered here, it is EOF
		ld	a,2
		adc	a,b
		push 	hl
		ld	iyh,b
		ld	iyl,c
		ld 	h,d
		ld 	l,e
		sbc 	hl,bc
		ld 	c,a
		jr	ap_finishup2
.apbranch2	call 	ap_getgamma	;use a gamma code * 256 for offset, another gamma code for length
		dec 	c
		ld	a,c
		sub	ixh
		jr 	z,ap_r0_gamma		;if gamma code is 2, use old r0 offset,
		dec 	a
		;do I even need this code?
		;bc=bc*256+(hl), lazy 16bit way
		ld 	b,a
		ld 	c,(hl)
		inc 	hl
		ld	iyh,b
		ld	iyl,c

		push 	bc
		
		call 	ap_getgamma

		ex 	(sp),hl		;bc = len, hl=offs
		push 	de
		ex 	de,hl

		ld	a,4
		cp	d
		jr 	nc,apskip2
		inc 	bc
		or	a
.apskip2	ld 	hl,127
		sbc 	hl,de
		jr 	c,apskip3
		inc 	bc
		inc 	bc
.apskip3		pop 	hl		;bc = len, de = offs, hl=junk
		push 	hl
		or 	a
.ap_finishup	sbc 	hl,de
		pop 	de		;hl=dest-offs, bc=len, de = dest
.ap_finishup2	ldir
		pop 	hl
		ld	ixh,b
		jr 	aploop

.ap_r0_gamma	call 	ap_getgamma		;and a new gamma code for length
		push 	hl
		push 	de
		ex	de,hl

		ld	d,iyh
		ld	e,iyl
		jr 	ap_finishup


.ap_getbit	ld	a,ixl
		add	a,a
		ld	ixl,a
		ret	nz
		ld	a,(hl)
		inc	hl
		rla
		ld	ixl,a
		ret

.ap_getgamma	ld 	bc,1
.ap_getgammaloop	call 	ap_getbit
		rl 	c
		rl 	b
		call 	ap_getbit
		jr 	c,ap_getgammaloop
		ret

#endasm

#asm
	._ram_address
		defw 0
	._ram_destination
		defw 0
#endasm

#ifdef COMPRESS_SCREENS
#asm
; -----------------------------------------------------------------------------
; RCS on-screen decoder by Einar Saukas & Antonio Villena (58 bytes)
; -----------------------------------------------------------------------------
; No parameters needed.
; -----------------------------------------------------------------------------

.drcs_onscreen
        ld      b, $02
.drcs_next
        ld      de, 256*(64)+1
.drcs_loop
        ld      h, d
        ld      a, e
        djnz    drcs_conv2 ; in first pass, skip first conversion

; In second pass, convert from format DA = x0x1x0R1R2c1c2c5 r1c3c4p1p2r2r3p3
;                           to format HA = x0x1x0R1R2p1p2r2 r3p3r1c3c4c1c2c5
        rrca               ; A = p3r1c3c4p1p2r2r3
        rrca               ; A = r3p3r1c3c4p1p2r2
        ld      c, a       ; C = r3p3r1c3c4p1p2r2
        xor     d
        and     $07
        xor     d          ; A = x0x1x0R1R2p1p2r2
        ld      h, a       ; H = x0x1x0R1R2p1p2r2
        xor     d
        xor     c          ; A = r3p3r1c3c4c1c2c5

; In first pass, convert from RCS format HA = x0x1x0R1R2c1c2c3 c4c5r1r2r3p1p2p3
;                              to format HL = x0x1x0R1R2c1c2c5 r1c3c4p1p2r2r3p3
; In second pass, convert from format HA = x0x1x0R1R2p1p2r2 r3p3r1c3c4c1c2c5
;            to regular screen format HL = x0x1x0R1R2p1p2p3 r1r2r3c1c2c3c4c5
.drcs_conv2
        ld      l, a      ; L = r3p3r1c3c4c1c2c5
        rlca              ; A = p3r1c3c4c1c2c5r3
        rrc     h         ; H = r2x0x1x0R1R2p1p2 (r2 to carry)
        rla               ; A = r1c3c4c1c2c5r3r2 (p3 to carry)
        rl      h         ; H = x0x1x0R1R2p1p2p3
        ld      c, a      ; C = r1c3c4c1c2c5r3r2
        xor     l
        and     $05
        xor     l         ; A = r3p3r1c3c4c5c2r2
        rrca              ; A = r2r3p3r1c3c4c5c2
        rrca              ; A = c2r2r3p3r1c3c4c5
        xor     c
        and     $67
        xor     c         ; A = r1r2r3c1c2c3c4c5
        ld      l, a      ; L = r1r2r3c1c2c3c4c5

; In-place byte swap permutation
        sbc     hl, de    ; HL < DE ?
        jr      nc, drcs_skip ; skip otherwise
        add     hl, de
        ld      c, (hl)   ; swap contents (HL) and (DE)
        ld      a, (de)
        ld      (hl), a
        ld      a, c
        ld      (de), a
.drcs_skip
        inc     b         ; djnz adjust
        inc     de        ; next address
        ld      a, d
        cp      2*8+72
        jr      nz, drcs_loop ; process next address
        djnz    drcs_next ; process next pass
        ret
#endasm
#endif

void unpack (unsigned int address, unsigned int destination) {
	if (address != 0) {
		ram_address [0] = address;
		ram_destination [0] = destination;

		#asm	
			ld hl, (_ram_address)
			ld de, (_ram_destination)
			call depack
			#ifdef COMPRESS_SCREENS
			call drcs_onscreen
			#endif
		#endasm
	}
}



#ifdef COMPRESSED_MAPS
#define  DMAP_BITSYMBOL 6
#define  DMAP_BUFFER    $5df2
void descomprimir_map ( unsigned char pantalla) {
	// Cargar en A el valor de n
	asm_number [0] = pantalla;
#asm

ld a, (_asm_number)

; -----------------------------------------------------------------------------
; decompress by Antonio Villena ( xx bytes)
; -----------------------------------------------------------------------------
; need address buffer in reg a
; -----------------------------------------------------------------------------
        ld      (desc1+1), sp
        inc     a
        ld      b, a
        ld      sp, map-1
        ld      de, $ffff
        ld      hl, fin
.suma    add     hl, de
        pop     af
        ld      e, a
        dec     sp
        djnz    suma
.desc1  ld      sp, 0
        ld      de, DMAP_BUFFER+149

; descompresor
        ld      b, $80
.byte_loop
        ld      a, 256 / 2^DMAP_BITSYMBOL

.repet  call    gbita
        jr      nc, repet
        ld      (de), a
        dec     de
.conti  ld      a, e
        cp      DMAP_BUFFER-1 & 255
        ret     z
        call    gbita
        rra
        jr      nc, byte_loop


.patro  push    de
        ld      a, 1

; determine length
.elias_gamma
        call    nc, gbita
        call    gbita
        rra
        jr      nc, elias_gamma
        inc     a
        ld      c, a

        xor     a
        ld      e, 14
        call    gbita
        call    gbita
        jr      z, sale
        dec     a
        call    gbita
        jr      z, sale2
        cp      4
        jr      nc, noca
        call    gbita
        call    gbita
        sub     3
        jr      sale
.noca   dec     e
.noce   call    gbita
        jr      nc, noce
        jr      z, sale2
        add     14
.sale   ld      e, a
.sale2  xor     a
        ld      d, a
        ld      a, b
        ld      b, d
        inc     e
; copy previous sequence
        ex      (sp), hl                ; store source, restore destination
        ex      de, hl
        add     hl, de
        lddr
        pop     hl                      ; restore source address (compressed data)
        ld      b, a
        jr      conti

.naaa   ld      b, (hl)
        dec     hl
        defb      $30
.gbita  and     a
        rl      b
        jr      z, naaa
        adc     a, a
        ret
.map
		BINARY "mapa_comprimido.bin"
.fin
#endasm
}
#endif

