// mainloop.h
// Churrera copyleft 2011 by The Mojon Twins.

void saca_a_todo_el_mundo_de_aqui (void) {
	sp_MoveSprAbs (sp_player, spritesClip, 0, VIEWPORT_Y + 30, VIEWPORT_X + 20, 0, 0);				
	for (gpit = 0; gpit < 3; gpit ++) {
		if (malotes [enoffs + gpit].t != 0)
			sp_MoveSprAbs (sp_moviles [gpit], spritesClip, 0, VIEWPORT_Y + 30, VIEWPORT_X + 20, 0, 0);
	}
}

unsigned char tone = 0xff;
extern unsigned int s_note_ptr [];

int itj;
unsigned char playing;
unsigned char life_old, score_old;
#if defined(TIMER_ENABLE) && defined(SHOW_TIMER_OVER)
unsigned char timer_old;
#endif
void do_game (void) {
	unsigned char *allpurposepuntero;
#ifdef COMPRESSED_LEVELS
	unsigned char mlplaying, level;
#endif	
#ifdef SCRIPTING_KEY_M
	int key_m;
#endif
#ifdef RANDOM_RESPAWN
	int x, y;
#else
	unsigned char x, y;
#endif
	unsigned char success;

    unsigned char srand_seed = (*((unsigned char *) (23672)));

    // presentacion
    #asm
	    ; Music generated by beepola
	    call musicstart
    #endasm
    srand_seed += *s_note_ptr;
    srand(srand_seed);
	#asm
		di
	#endasm
	
	// splib2 initialization
	sp_Initialize (7, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 56, 14, AD_FREE);
	
	// Define keys and default controls
	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
#ifdef SCRIPTING_KEY_M
	key_m = sp_LookupKey ('m');
#endif
	joyfunc = sp_JoyKeyboard;

	// Load tileset
	allpurposepuntero = tileset;
	for (itj = 0; itj < 256; itj++) {
		sp_TileArray (itj, allpurposepuntero);
		allpurposepuntero += 8;
	}

	// Clipping rectangle
	spritesClipValues.row_coord = VIEWPORT_Y;
	spritesClipValues.col_coord = VIEWPORT_X;
	spritesClipValues.height = 20;
	spritesClipValues.width = 30;
	spritesClip = &spritesClipValues;
	
	// Sprite creation
#ifdef NO_MASKS
	sp_player = sp_CreateSpr (sp_OR_SPRITE, 3, sprite_2_a, 1, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_2_b, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_2_c, TRANSPARENT);
	player.current_frame = player.next_frame = sprite_2_a;
	
	for (gpit = 0; gpit < 3; gpit ++) {
		sp_moviles [gpit] = sp_CreateSpr(sp_OR_SPRITE, 3, sprite_9_a, 1, TRANSPARENT);
		sp_AddColSpr (sp_moviles [gpit], sprite_9_b, TRANSPARENT);
		sp_AddColSpr (sp_moviles [gpit], sprite_9_c, TRANSPARENT);	
		en_an [gpit].current_frame = sprite_9_a;
	}
#else
	sp_player = sp_CreateSpr (sp_MASK_SPRITE, 3, sprite_2_a, 1, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_2_b, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_2_c, TRANSPARENT);
	player.current_frame = player.next_frame = sprite_2_a;
	
	for (gpit = 0; gpit < 3; gpit ++) {
		sp_moviles [gpit] = sp_CreateSpr(sp_MASK_SPRITE, 3, sprite_9_a, 2, TRANSPARENT);
		sp_AddColSpr (sp_moviles [gpit], sprite_9_b, TRANSPARENT);
		sp_AddColSpr (sp_moviles [gpit], sprite_9_c, TRANSPARENT);	
		en_an [gpit].current_frame = en_an [gpit].next_frame = sprite_9_a;
	}
#endif

#ifdef PLAYER_CAN_FIRE
	for (gpit = 0; gpit < MAX_BULLETS; gpit ++) {
		sp_bullets [gpit] = sp_CreateSpr (sp_OR_SPRITE, 2, sprite_19_a, 1, TRANSPARENT);
		sp_AddColSpr (sp_bullets [gpit], sprite_19_b, TRANSPARENT);
	}
#endif

    cortina ();
    playing = 2; // used for music in menu -- see joyfunc

	while (1) {
		// Here the title screen
		sp_UpdateNow();
		blackout ();
		unpack ((unsigned int) (s_title), 16384);
		select_joyfunc ();
		
#ifdef COMPRESSED_LEVELS
		mlplaying = 1;
		level = 0;
#ifndef REFILL_ME
		player.life = PLAYER_LIFE;
#endif
		while (mlplaying) {
			prepare_level (level);
			blackout_area ();
			peta_el_beeper (7);
			espera_activa (100);
#endif
				
#ifndef DIRECT_TO_PLAY
		// Clear screen and show game frame
		cortina ();
		sp_UpdateNow();
#endif

		// Let's do it.

		playing = 1;
		init_player ();

		paint_marco();

#ifndef COMPRESSED_LEVELS	
		n_pant = SCR_INICIO;
#endif		
		maincounter = 0;
		
		draw_scr ();

		half_life = 0;
			
		score_old = life_old = 0xff;
#if defined(TIMER_ENABLE) && defined(SHOW_TIMER_OVER)
		timer_old = 0;
#endif
		success = 0;
		
		while (playing) {
		    if (player.life != life_old) {
			    print_number2 (LIFE_X, LIFE_Y, player.life);
			    life_old = player.life;
		    }
			

#if defined(TIMER_ENABLE) && defined(SHOW_TIMER_OVER)
			if (ctimer.t != timer_old) {
				print_number2 (1, 1, ctimer.t);
				timer_old = ctimer.t;
			}
#endif
			maincounter ++;
			half_life = !half_life;
			
			// Move player
			move ();
			
			// Move enemies
			mueve_bicharracos ();

			// Render		
			for (gpit = 0; gpit < 3; gpit ++) {
				x = malotes [enoffs + gpit].x;
				y = malotes [enoffs + gpit].y;

				sp_MoveSprAbs (sp_moviles [gpit], spritesClip, en_an [gpit].next_frame - en_an [gpit].current_frame, VIEWPORT_Y + (y >> 3), VIEWPORT_X + (x >> 3),x & 7, y & 7);
				en_an [gpit].current_frame = en_an [gpit].next_frame;
			}

			// Precalc this, comes handy:
			x = player.x >> 6;
			y = player.y >> 6;
			
			if ( !(player.estado & EST_PARP) || !(half_life) )
				sp_MoveSprAbs (sp_player, spritesClip, player.next_frame - player.current_frame, VIEWPORT_Y + (y >> 3), VIEWPORT_X + (x >> 3), x & 7, y & 7);
			else
				sp_MoveSprAbs (sp_player, spritesClip, player.next_frame - player.current_frame, -2, -2, 0, 0);
			
			player.current_frame = player.next_frame;
			
			
			// Update to screen
			sp_UpdateNow();
			

            switch(n_pant){
                case 8:
                case 9:
                case 12:
                case 13:
                case 17:
                case 18:
                case 28:
                case 29:
			    if (player.x == 0 && player.vx < 0) {
				    n_pant --;
				    draw_scr ();
				    player.x = 14336;
			    }
			    if (player.x == 14336 && player.vx > 0) {
				    n_pant ++;
				    draw_scr ();
				    player.x = 0;
			    }
			}
			
            switch(player.estado){
                case EST_OPEN:
                    // TODO: calcular nueva sala.
                    calc_nextroom();
				    malotes_k = 0; //reset enemies
				    draw_scr ();
				    player.estado = EST_NORMAL;
				    calc_nextdoor();
				    peta_el_beeper (2); // cierra la puerta
				    break;
				case EST_FAIL:
                    --player.life;
                    player.x = 7 << 10;
                    player.y = 7 << 10;
                    n_pant= 3;
                    player.keys = 0;
				    malotes_k = 0; // reset enemies
                    recover_pal();
				    draw_scr ();
                    paint_marco();
				    player.estado = EST_NORMAL;
				    peta_el_beeper (2); // cierra la puerta
				    break;
				case EST_BEAT:
				    draw_scr ();
                    paint_marco();
				    player.estado = EST_NORMAL;
				    peta_el_beeper (4);
				    break;
				case EST_WIN:
					success = 1;
					playing = 0;					
            }
			
			// Game over condition
			if (player.life == 0) {
				playing = 0;				
			}
		}
		
		saca_a_todo_el_mundo_de_aqui ();
		sp_UpdateNow ();
		
		if (success == 1) game_ending (); 
		else if (success == 2) ending_cured ();		
		else game_over ();
		cortina ();
	}
}
